#include <stdlib.h>
#include <math.h>
#include "growing.h"


Growing::Growing(int w, int h) {
	width = w;
	height = h;
	disttable = NULL;
}

Growing::~Growing(void) {
	free(disttable);
}

void Growing::init(void) {
	disttable = (int*) malloc(sizeof(int)*width*height);
	int pointx[3] = {135,250,230};
	int pointy[3] = {150,50,200};
	int extra[3] = {0,20,55};

	int *ptr = disttable;
	maxDist = 0;
	for (int y = 0; y < height; y++) {
		for (int x = 0; x < width; x++) {
			int min = (int)((1<<8)*(hypot(pointx[0]-x,pointy[0]-y)+extra[0]));
			for (int i = 1; i < 3; i++) {
				int d = (int)((1<<8)*(hypot(pointx[i]-x,pointy[i]-y)+extra[i]));
				if (d<min) min = d;
			}
			if (min>maxDist) maxDist = min;
			*ptr++ = min;
		}
	}
}

void Growing::draw(unsigned int *out, unsigned int *in1, unsigned int *in2, int time, int duration) {
	int pos = maxDist*time/duration;
	int length = width*height;
	int *distptr = disttable;
	for (int i = 0; i < length; i++) {
		if ((*distptr>>9)==(pos>>9)) *out = 0;
		else if (*distptr<pos) *out = *in2;
		else *out = *in1;
		distptr++;
		out++;
		in1++;
		in2++;
	}
}


