#include <stdlib.h>
#include <math.h>
#include "invert.h"

#ifndef M_PI
#define M_PI 3.141592654
#endif

Invert::Invert(int w, int h) {
	width = w;
	height = h;
	sintable = NULL;
}

Invert::~Invert(void) {
	free(sintable);
}

void Invert::init(void) {
	sintable = (unsigned char*) malloc(sizeof(char)*512);
	for (int i = 0; i < 512; i++)
		sintable[i] = (int) (128+127*sin(2*M_PI*i/512));
}

void Invert::draw(unsigned int *buffer, int time) {
	int xPos;
	for (int y = 0; y < height; y++) {
		xPos = 100 + sintable[(y-time/5)&0x01FF]/3 + (25+sintable[(y*2-time/7)&0x01FF]/2)*sintable[(y*10+2*time/3)&0x01FF]/800;
		for (int x = 0; x < xPos; x++) {
			*buffer = ~*buffer;
			buffer++;
		}
		buffer += (width-xPos);
	}
}

