#include <SDL.h>
#include <SDL_thread.h>
#include "thread.h"
#include "audio.h"
#include "modplayer.h"

static int thread(void *ptr) {
	start_play(ModPlayer_read,ptr);
	stop_audio();
	return 0;
}

#ifndef NOTHREAD
static SDL_Thread *playerThread;
#endif

void start_thread(ModPlayer *player) {
#ifndef NOTHREAD
	playerThread = SDL_CreateThread(thread,player);
#else
	start_play(ModPlayer_read,player);
#endif
}

void join_thread(void) {
#ifndef NOTHREAD
	SDL_WaitThread(playerThread,NULL);
#else
	while (is_playing()) SDL_Delay(10);
	stop_audio();
#endif
}

void msleep(int msec) {
	SDL_Delay(msec);
}

