#ifndef __SHOWTEXT_H
#define __SHOWTEXT_H

class ShowText {
	public:
		ShowText(int width, int height);
		~ShowText(void);
		void init(void);
		void setFont(unsigned int *font, char *chars, bool lowerCase, int charWidth, int charHeight, int width, bool plain, unsigned int color);
		void setText(char **text, int time);
		void draw(unsigned int *buffer, int time);
	private:
		void drawString(unsigned int *buffer, char *string);
		void drawRow(unsigned int *buffer, char *row, int y);
		void drawChar(unsigned int *buffer, char c, int bufferX, int bufferY);
		void drawOverlay(unsigned int *buffer, unsigned int *overlay, int x, int y);
		int getIndex(char c);
		int width, height;
		unsigned int *font;
		char *fontChars;
		bool lowerCase;
		int charWidth, charHeight;
		int fontImageWidth;
		bool plain;
		unsigned int color;
		unsigned int **texts;
		int textNum;
		int bufferWidth, bufferHeight;
		int textTime;
		int startTime;
};

#endif
